from os import path
from re import compile, Pattern, sub


def replace(search, replace, filename):
	file = open(filename, "r")
	content = file.read()
	file.close()
	file = open(filename, "w+")
	if type(search) == str:
		content = content.replace(search, replace)
	elif type(search) == Pattern:
		content = sub(search, replace, content)
	file.write(content)
	file.close()

d = path.dirname(path.realpath(__file__))

try:
	import orjson
	replace("from json import", "from orjson import", "%s/wsgi.py" % d)
	replace("from json import", "from orjson import", "%s/request.py" % d)
	replace("from json import dumps as jdumps", "from orjson import dumps", "%s/response.py" % d)
	replace(compile(r"def dumps\([^\n]+\n"), "", "%s/response.py" % d)
except ModuleNotFoundError:
	try:
		import ujson
		replace("from json import", "from ujson import", "%s/wsgi.py" % d)
		replace("from json import", "from ujson import", "%s/request.py" % d)
		replace("from json import", "from ujson import", "%s/response.py" % d)
	except ModuleNotFoundError:
		pass

imports = """from .request import Request
from .response import Response
from .route import Route
from .wsgi import WSGI
"""
init = open("%s/__init__.py" % d, "w+")
init.write(imports)
init.close()
exec(imports)
